<?php

if (defined('PAYMENT_NOTIFICATION'))
{
	if (!empty($_REQUEST['order_id'])) {
		$order_id = $_REQUEST['order_id'];
	}

	if (!isset($_SESSION['gooyapay']))
	{
		session_destroy();
		session_id($_GET['shf_key']);
		session_start();
	}

	$order_info = fn_get_order_info($order_id);
	if (empty($processor_data) && !empty($order_info)) {
		$processor_data = fn_get_processor_data($order_info['payment_id']);
	}

	$_REQUEST['order_id'] = $order_info['timestamp'] . '_' . $_REQUEST['order_id'];

	if (isset($_POST['PaymentStatus']) && $_POST['PaymentStatus'] == 'OK')
	{
		$Authority 	= (isset($_POST['Authority']) && $_POST['Authority'] != '') ? $_POST['Authority'] : '';
		$InvoiceID 	= (isset($_POST['InvoiceID']) && $_POST['InvoiceID'] != '') ? $_POST['InvoiceID'] : '';

	    $currency_f = CART_SECONDARY_CURRENCY;
	    if ($processor_data['processor_params']['currency'] == 'shop_cur') {
	        $amount = fn_format_price_by_currency($order_info['total']);
	    } else {
	        $amount = fn_format_price($order_info['total'], $processor_data['processor_params']['currency']);
	        $currency_f = $processor_data['processor_params']['currency'];
	    }

		// $currency = $order_info['secondary_currency'];
		// $amount = $order_info['total'];

		$ch = curl_init('https://gooyapay.ir/webservice/rest/PaymentVerification');
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type' => 'application/json'));
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post = array(
				'MerchantID'  => $processor_data['processor_params']['gp_merchant'],
				'Amount'      => intval($amount),
				'Authority'   => $Authority
			)));
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		$response = curl_exec($ch);
		$error = curl_error($ch);
		$info = curl_getinfo($ch);
		curl_close($ch);
		$result = json_decode($response);
		if (isset($result->Status) && $result->Status == 100)
		{
			$order_status = $processor_data['processor_params']['paid_order_status'];
			//$order_status = $processor_data['processor_params']['statuses']['completed'];
			$pp_response = ['order_status' => $order_status, 'payment_id' => $result->RefID, 'transaction_id' => $result->RefID];
			//fn_change_order_status($order_id, $pp_response['order_status']); // '', false
			//fn_update_order_payment_info($order_id, ['order_id' => $_REQUEST['order_id'], 'payment_id' => $result->RefID]);
			fn_finish_payment($order_id, $pp_response);
			//fn_clear_cart(Tygh::$app['session']);
			//fn_clear_cart($_SESSION['cart']);
			fn_order_placement_routines('route', $order_id);
			fn_redirect('index.php?dispatch=orders.details&order_id=' . $order_id);
			exit();
		}
		else
		{
			if (isset($result->Message))
			{
				$error = $result->Message;
			}
			if (!$error)
			{
				$error = 'UnKnown Error on verifying GooyaPay.ir Payment...';
			}
			$pp_response = ['order_status' => 'F'];
		}
	}
	else
	{
		$error = 'تراکنش توسط کاربر لغو شد';
		$pp_response = ['order_status' => 'F'];
	}
	fn_change_order_status($order_id, $pp_response['order_status']);
    //fn_redirect('/cart');
    header('location: index.php?dispatch=orders.details&order_id='.$order_id.'&msg='.$error);
    exit();

}
else
{
    if (empty($processor_data) && !empty($order_info)) {
        $processor_data = fn_get_processor_data($order_info['payment_id']);
    }

    $currency_f = CART_SECONDARY_CURRENCY;
    if ($processor_data['processor_params']['currency'] == 'shop_cur') {
        $amount = fn_format_price_by_currency($order_info['total']);
    } else {
        $amount = fn_format_price($order_info['total'], $processor_data['processor_params']['currency']);
        $currency_f = $processor_data['processor_params']['currency'];
    }

	// $currency = $order_info['secondary_currency'];
	// $amount = $order_info['total'];

	$response = fn_url('payment_notification.response?payment=gooyapay&order_id=' . $order_info['order_id'], AREA, 'current');
	$cancel   = fn_url('payment_notification.fail?payment=w1&orderId=' . $order_info['order_id']);
	$callback = fn_url('index.php?dispatch=payment_notification.ok&payment=gooyapay&order_id=' . $order_info['order_id'].'&shf_key=' . session_id());

	$ch = curl_init('https://gooyapay.ir/webservice/rest/PaymentRequest');
	curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type' => 'application/json'));
	curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($post = array(
			'MerchantID'  => $processor_data['processor_params']['gp_merchant'],
			'Amount'      => intval($amount),
			'InvoiceID'   => $order_info['order_id'],
			'Description' => '',
			'FullName'    => $order_info['firstname'] . ' ' .$order_info['lastname'],
			'Email'       => $order_info['email'],
			'Mobile'      => $order_info['phone'],
			'CallbackURL' => $callback
		)));
	curl_setopt($ch, CURLOPT_TIMEOUT, 30);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	$response = curl_exec($ch);
	$error = curl_error($ch);
	$info = curl_getinfo($ch);
	curl_close($ch);
	$result = json_decode($response);
	if (isset($result->Status) && $result->Status == 100)
	{
		$_SESSION['gooyapay'] = $order_info['order_id'];
		fn_create_payment_form($result->PaymentUrl, array(), 'GooyaPay', false, 'get', false, 'parent');
	}
	else
	{
		if (isset($result->Message))
		{
			$error = $result->Message;
		}
		if (!$error)
		{
			$error = 'UnKnown Error on requesting GooyaPay.ir Payment...';
		}
		@header('Content-Type: text/html; charset=utf-8');
		echo "<p>Error : {$error} <br />OrderID : {$order_info['order_id']} </p>";
		exit;die;
	}
}
